 Unit GrText;

 {------------------------------------}
               INTERFACE
 {------------------------------------}

   Uses Dos,Graph,Crt;

   Const

   AppHandle: Boolean = True;
   ESCFlag  : Boolean = False;

   EmptyBorder  =0;
   SingleBorder =0;
   DoubleBorder =0;

   BorderChar: array[0..2,1..6] of Char =
   ((#32,  #32,  #32,  #32,  #32,  #32),
   (#218, #196, #191, #179, #192, #217),
   (#201, #205, #187, #186, #200, #188));

   Procedure ClrScr;
   Procedure Colors(Text,Back: Byte);
   Function GetMaxChar: Byte;
   Function GetMaxLine: Byte;
   Procedure GetWindGraphCoord(var X1,Y1,X2,Y2: Integer);
   Procedure GotoXY(X,Y: Byte);
   Function GraphCoordX(X: Byte): Integer;
   Function GraphCoordY(Y: Byte): Integer;
   Procedure GraphWriteOn;
   Procedure GraphWriteOff;
   Procedure SetFont(Fnt: Pointer; X,Y: Byte);
   Procedure Scrolling(N: Integer);
   Procedure TextBackGround(Color: Byte);
   Procedure TextColor(Color: Byte);
   Function TextCoordX(X: Integer): Byte;
   Function TextCoordY(Y: Integer): Byte;
   Function WhereX: Byte;
   Function WhereY: Byte;
   Procedure Window(X1,Y1,X2,Y2: Byte);
   Procedure SetWindow(X1,Y1,X2,Y2,Border: Byte;
   Header: String; Clip,Build,Play: Boolean);
   Function RegisterChrFile(S: String): Integer;
   Function RegisterChrFont(Font: Pointer): Integer;
   Procedure OutString(S: String; Font,Angle: Integer; MX,MY: Double);

 {------------------------------------}
             IMPLEMENTATION
 {------------------------------------}

   Type  {............................}

   aob =array[0..MaxInt] Of Byte;

   Const {............................}

   ChangeWR: Boolean = False;
   Font: ^aob = NIL;
   TCol: Byte = LightGray;
   BCol: Byte = Black;

   Var   {............................}

   OldOut,OldInp: Text;
   Xt,Yt: Byte;
   Xg,Yg: Integer;
   X1t,Y1t,X2t,Y2t: Byte;
   X1g,Y1g,X2g,Y2g: Integer;
   MaxChar: Byte;
   MaxLine: Byte;
   XF,YF: Byte;
   Adapter: Byte;

 {------------------------------------------------------------------------}

   Procedure WriteChar(X,Y: Integer; Ch: Byte);
   var
           k: Integer;
         b,j: Byte;
   begin
    for k:=0 to Pred(YF) do
    begin
     b:=Font^[Ch*YF+k];
     Case Adapter Of
   0: begin
       for j:=0 to 7 do
       if b and (128 shr j) <>0 then PutPixel(X*XF+j,Y+k,TCol)
       else if BCol <>0 then PutPixel(X*XF+j,Y+k,BCol);
      end;
   1: asm
       mov ax,$A000;
       mov es,ax
       mov bx,y
       add bx,k
       mov cl,4
       shl bx,cl
       mov dx,bx
       mov cl,2
       shl bx,cl
       add bx,dx
       add bx,x

       mov dx,$3CE
       mov al,5
       out dx,al
       inc dx
       mov al,2
       out dx,al

       mov dx,$3CE
       mov al,8
       out dx,al
       inc dx
       mov al,b
       out dx,al
       mov al,es:[bx]
       mov al,TCol
       mov es:[bx],al
       mov dl,BCol
       cmp dl,0
       je @0

       mov dx,$3CE
       mov al,8
       out dx,al
       inc dx
       mov al,b
       not al
       out dx,al
       mov al,es:[bx]
       mov al,BCol
       mov es:[bx],al
       @0:

      end;
     end;
    end;
   end;

 {------------------------------------------------------------------------}

   Function GraphRead(var F: TextRec): Integer; Far;
   Var
          X0t: Byte;
          YUp,YDn: Integer;
          InsFlag: Boolean;
          Cur : Pointer;
          Back: Pointer;
          S: String;
          C: Char;

   Const
          CSize: Word =0;

 {-------------------------------------------}

   Procedure SetCursor;
   Var
        FillInfo: FillSettingsType;
   Begin
    if CSize <>0 then
    begin
     FreeMem(Back,CSize);
     FreeMem(Cur ,CSize);
    end;
    YDn:=Yg+YF-1;
    if InsFlag then YUp:=YDn-2 else YUp:=Yg;
    CSize:=ImageSize(Xg,YUp,Xg+XF-1,YDn);
    GetMem(Back,CSize);
    GetImage(Xg,YUp,Xg+XF-1,YDn,Back^);
    GetFillSettings(FillInfo);
    SetFillStyle(SolidFill,TCol);
    Bar(Xg,YUp,Xg+XF-1,YDn);
    With FillInfo do SetFillStyle(Pattern,Color);
    GetMem(Cur,CSize);
    GetImage(Xg,YUp,Xg+XF-1,YDn,Cur^);
    PutImage(Xg,YUp,Back^,NormalPut);
   End;

 {-------------------------------------------}

   Procedure Cursor;
   Var    k: Integer;
   Const  D =10;

   Begin
    GetImage(Xg,YUp,Xg+XF-1,YDn,Back^);
    While not KeyPressed do
    begin
     PutImage(Xg,YUp,Cur^,NormalPut);
     for k:=1 to 10 do if not KeyPressed then Delay(D);
     PutImage(Xg,YUp,Back^,NormalPut);
     for k:=1 to 10 do if not KeyPressed then Delay(D);
    end;
   End;

 {-------------------------------------------}

   Procedure Home;
   Begin
    GotoXY(X0t,WhereY);
   End;
 {-------------------------------------------}

   Procedure Left;
   Begin
    if WhereX> X0t then
    GotoXY(Pred(WhereX),WhereY);
   End;
 {-------------------------------------------}

   Procedure Right;
   Begin
    if WhereX-X0t <Length(s) then
    GotoXY(Succ(WhereX),WhereY);
   End;
 {-------------------------------------------}

   Procedure EndKey;
   Begin
    GotoXY(X0t+Length(s),WhereY);
   End;
 {-------------------------------------------}

   Procedure Ins;
   Begin
    InsFlag:=not InsFlag;
    SetCursor;
   End;
 {-------------------------------------------}

   Procedure WriteString;
   Var  k: Byte;
   Begin
    for k:=1 to Length(s) do
    WriteChar(X1t+X0t+k-3,Yg,Ord(s[k]));
    WriteChar(X1t+X0t+Length(s)-2,Yg,32);
   End;
 {-------------------------------------------}

   Procedure Del;
   Var  n: Byte;
   Begin
    n:=WhereX-X0t;
    if n <Length(s) then
    begin
     Delete(s,Succ(n),1);
     WriteString;
    end;
   End;
 {-------------------------------------------}

   Procedure BackSpace;
   Var  n: Byte;
   Begin
    n:=WhereX-X0t;
    if n>= 1 then
    begin
     Delete(s,n,1);
     WriteString;
     GotoXY(Pred(WhereX),WhereY);
    end;
   End;
 {-------------------------------------------}

   Procedure AnyChar;
   Var  n: Byte;
   Begin
    n:=WhereX-X0t;
    if n =Length(s) then
    if X1t+X0t+Length(s) <=X2t then S:=S+c else
    else
    if InsFlag and (X1t+X0t+Length(s) <=X2t) then
    Insert(C,s,Succ(n)) else S[Succ(n)]:=C;
    WriteString;
    GotoXY(Succ(WhereX),WhereY);
   End;
 {-------------------------------------------}

   Procedure Enter;
   Var  k: Byte;
   Begin With F do
    begin
     for k:=1 to Length(s) do
     BufPtr^[BufEnd+k-1]:=s[k];
     BufEnd:=Length(s);
     if BufEnd =0 then
     begin
      BufEnd:=1;
      BufPtr^[0]:=' ';
     end;
    end;
    GotoXY(1,Succ(WhereY));
   End;
 {-------------------------------------------}

   Procedure ESC;
   Begin With F do
    begin
     BufEnd:=1;
     BufPtr^[0]:=' ';
     ESCFlag:=True;
    end;
   End;
 {------------------------------------------------------}

   Begin With F do
    if (Mode =fmInput) and (BufEnd =0) then
    begin
     X0t:=WhereX;
     s:='';
     InsFlag:=True;
     ESCFlag:=False;
     SetCursor;

     Repeat
      Cursor;
      c:=ReadKey;
      Case C Of
   #0: Case ReadKey Of
        #71: Home;
        #75: Left;
        #77: Right;
        #79: EndKey;
        #82: Ins;
        #83: Del;
        else C:=#0;
       end;
   #8: BackSpace;
  #13: Enter;
  #27: ESC;
  else AnyChar;
      end;
     Until (C =#13) or (C =#27);
     FreeMem(Back,CSize);
     FreeMem(Cur ,CSize);
     CSize:=0;
    end;
    GraphRead:=0;
   End;
 {------------------------------------------------------}

   Function GraphWrite(var F: TextRec): Integer; Far;
   Var
          Drv,Mode: Integer;
                 k: Integer;
               Reg: Registers;
   Begin
    if Font =Nil then exit;
    DetectGraph(Drv,Mode);
    if AppHandle and (Drv In [3..5,9]) then Adapter:=1
    else Adapter:=0;
    With F do
    if (Mode =fmOutPut) and (BufPos> 0) then
    begin
     for k:=0 to Pred(BufPos) do
     Case BufPtr^[k] Of
  #7: With Reg do
      begin
       ah:=$E;
       al:=7;
       Intr($10,Reg);
      end;
  #8: if k> BufEnd then
      begin
       WriteChar(Xt-2,Yg,32);
       GotoXY(Pred(WhereX),WhereY);
      end;
 #10: if Succ(Yt) In [Y1t..Y2t] then
      GotoXY(WhereX,Succ(WhereY));
 #13: GotoXY(1,WhereY);
 else begin
       WriteChar(Pred(Xt),Yg,Ord(BufPtr^[k]));
       if Succ(Xt) In [X1t..X2t] then
       GotoXY(Succ(WhereX),WhereY) else
       if Succ(Yt) In [Y1t..Y2t] then
       GotoXY(1,Succ(WhereY));
      end;
     end;
     BufPos:=0;
    end;
    GraphWrite:=0;
   End;
 {------------------------------------------------------}

   Function Zero(var F: TextRec): Integer; Far;
   Begin
    Zero:=0;
   End;
 {------------------------------------------------------}

   Function Flush(var F: TextRec): Integer; Far;
   Begin
    With F do
    begin
     BufPos:=0;
     BufEnd:=0;
    end;
    Flush:=0;
   End;
 {------------------------------------------------------}

   Procedure ClrScr;
   Var  FillInfo: FillSettingsType;
   Begin
    if Font <>Nil then
    begin
     GetFillSettings(FillInfo);
     SetFillStyle(SolidFill,BCol);
     Bar(X1g,Y1g,X2g,Y2g);
     With FillInfo do SetFillStyle(Pattern,Color);
     GotoXY(1,1);
    end;
   End;
 {------------------------------------------------------}

   Procedure Colors(Text,Back: Byte);
   Begin
    TextColor(Text);
    TextBackGround(Back);
   End;
 {------------------------------------------------------}

   Function GetMaxChar: Byte;
   Begin
    GetMaxChar:=MaxChar;
   End;
 {------------------------------------------------------}

   Function GetMaxLine: Byte;
   Begin
    GetMaxLine:=MaxLine;
   End;
 {------------------------------------------------------}

   Procedure GetWindGraphCoord(var X1,Y1,X2,Y2: Integer);
   Begin
    X1:=X1g;
    Y1:=Y1g;
    X2:=X2g;
    Y2:=Y2g;
   End;
 {------------------------------------------------------}

   Procedure GotoXY(X,Y: Byte);
   Begin
    if (Font <>Nil) and
    (X In [1..MaxChar]) and (Y In [1..MaxLine]) and
    (X <=X2t-X1t+1) and (Y <=Y2t-Y1t+1) then
    begin
     Xt:=X+X1t-1;
     Yt:=Y+Y1t-1;
     Xg:=GraphCoordX(Xt);
     Yg:=GraphCoordY(Yt);
    end;
   End;
 {------------------------------------------------------}

   Function GraphCoordX(X: Byte): Integer;
   Begin
    if Font <>Nil then
    GraphCoordX:=Pred(X)*XF else GraphCoordX:=-1;
   End;
 {------------------------------------------------------}

   Function GraphCoordY(Y: Byte): Integer;
   Begin
    if Font <>Nil then
    GraphCoordY:=Pred(Y)*YF else GraphCoordY:=-1;
   End;
 {------------------------------------------------------}

   Procedure GraphWriteOn;
   Begin
    if not ChangeWR then
    begin
     Move(OutPut,OldOut,SizeOf(OutPut));
     With TextRec(OutPut) do
     begin
      OpenFunc :=@Zero;
      CloseFunc:=@Zero;
      FlushFunc:=@GraphWrite;
      InOutFunc:=@GraphWrite;
     end;
     Move(InPut,OldInp,SizeOf(InPut));
     With TextRec(InPut) do
     begin
      OpenFunc :=@Zero;
      CloseFunc:=@Zero;
      FlushFunc:=@Flush;
      InOutFunc:=@GraphRead;
     end;
     ChangeWR:=True;
    end;
   End;
 {------------------------------------------------------}

   Procedure GraphWriteOff;
   Begin
    if ChangeWR then
    begin
     Move(OldOut,OutPut,SizeOf(OutPut));
     Move(OldInp,InPut,SizeOf(InPut));
     ChangeWR:=False;
    end;
   End;
 {------------------------------------------------------}

   Procedure SetFont(Fnt: Pointer; X,Y: Byte);
   Begin
    Font:=Fnt;
    MaxChar:=Succ(GetMaxX) Div X;
    MaxLine:=Succ(GetMaxY) Div Y;
    XF:=X;
    YF:=Y;
    Window(1,1,MaxChar,MaxLine);
   End;
 {------------------------------------------------------}

   Procedure Scrolling(N: Integer);
   Var
          k  : Byte;
          x,y: Word;
          LineSize: Word;
          P: Pointer;
          FillInfo: FillSettingsType;
   Begin
    GetFillSettings(FillInfo);
    SetFillStyle(SolidFill,BCol);
    LineSize:=ImageSize(x1g,y1g,x2g,y1g+YF);
    if Abs(N)>= Y2t-Y1t+1 then Bar(X1g,Y1g,X2g,Y2g)
    else if N> 0 then
    begin
     GetMem(P,LineSize);
     for k:=0 to Y2t-Y1t-N do
     begin
      GetImage(X1g,Y1g+(N+k)*YF,X2g,Y1g+(N+k+1)*YF,P^);
      PutImage(X1g,Y1g+k*YF,P^,NormalPut);
     end;
     FreeMem(P,LineSize);
     Bar(X1g,Y2g-N*YF,X2g,Y2g);
    end
    else if N <0 then
    begin
     GetMem(P,LineSize);
     N:=Abs(N);
     for k:=Y2t-Y1t-N downto 1 do
     begin
      GetImage(X1g,Y1g+(k-1)*YF,X2g,Y1g+k*YF,P^);
      PutImage(X1g,Y2g-(Y2t-Y1t-N-k+1)*YF,P^,NormalPut);
     end;
     FreeMem(P,LineSize);
     Bar(X1g,Y1g,X2g,Y1g+N*YF);
    end;
    With FillInfo do SetFillStyle(Pattern,Color);
   End;
 {------------------------------------------------------}

   Procedure TextBackGround(Color: Byte);
   Begin
    BCol:=Color;
   End;
 {------------------------------------------------------}

   Procedure TextColor(Color: Byte);
   Begin
    TCol:=Color;
   End;
 {------------------------------------------------------}

   Function TextCoordX(X: Integer): Byte;
   Begin
    if (Font <>Nil) and (X In [0..GetMaxX]) then
    TextCoordX:=Round(X/MaxChar)+1 else TextCoordX:=0;
   End;
 {------------------------------------------------------}

   Function TextCoordY(Y: Integer): Byte;
   Begin
    if (Font <>Nil) and (Y In [0..GetMaxY]) then
    TextCoordY:=Round(Y/MaxLine)+1 else TextCoordY:=0;
   End;
 {------------------------------------------------------}

   Function WhereX: Byte;
   Begin
    if Font <>Nil then WhereX:=Xt-X1t+1 else WhereX:=0;
   End;
 {------------------------------------------------------}

   Function WhereY: Byte;
   Begin
    if Font <>Nil then WhereY:=Yt-Y1t+1 else WhereY:=0;
   End;
 {------------------------------------------------------}

   Procedure Window(X1,Y1,X2,Y2: Byte);
   Begin
    if (Font <>Nil) and
    (X1 In [1..MaxChar]) and (Y1 In [1..MaxLine]) and
    (X2 In [1..MaxChar]) and (Y2 In [1..MaxLine]) and
    (X2>= X1) and (Y2>=Y1) then
    begin
     Xt:=X1;
     Yt:=Y1;
     Xg:=XF*Pred(Xt);
     Yg:=YF*Pred(Yt);
     X1t:=X1;
     Y1t:=Y1;
     X2t:=X2;
     Y2t:=Y2;
     X1g:=XF*Pred(X1t);
     Y1g:=YF*Pred(Y1t);
     X2g:=XF*X2t;
     Y2g:=YF*Y2t;
    end;
   End;
 {------------------------------------------------------}

   Procedure SetWindow(X1,Y1,X2,Y2,Border: Byte;
   Header: String; Clip,Build,Play: Boolean);
   Const
            TonBeg = 400;
            TonEnd = 800;
            Pause  = 5;
            N      = 20;
   Var

            k,X,xx1,yy1,xx2,yy2,dx,dy: Byte;
            dt: Integer;
   Begin
    if (Font <>Nil) and
    (X1 In [1..MaxChar]) and (Y1 In [1..MaxLine]) and
    (X2 In [1..MaxChar]) and (Y2 In [1..MaxLine]) and
    (X2>= X1) and (Y2>=Y1) then
    begin
     if Build and ((X2-X1>= 4) or (Y2-Y1>= 4)) then
     begin
      X:=(X2-X1) Div 2;
      if X> 1 then
      begin
       xx1:=X1+X-1;
       xx2:=X1+X+1;
      end else
      begin
       xx1:=X1;
       xx2:=X2;
      end;
      X:=(Y2-Y1) Div 2;
      if X> 1 then
      begin
       yy1:=Y1+X-1;
       yy2:=Y1+X+1;
      end else
      begin
       yy1:=Y1;
       yy2:=Y2;
      end;
      dx:=(X2-X1) Div N;
      if dx= 0 then dx:=1;
      dy:=(Y2-Y1) Div N;
      if dy= 0 then dy:=1;
      dt:=(TonEnd-TonBeg) Div N;
      for k:=0 to Pred(N) do
      begin
       if Play then Sound(TonBeg+k*dt);
       Window(xx1,yy1,xx2,yy2);
       ClrScr;
       if xx1> X1 then Dec(xx1,dx);
       if xx2 <X2 then Inc(xx2,dx);
       if yy1> Y1 then Dec(yy1,dy);
       if yy2> Y2 then Inc(yy2,dy);
      end;
      NoSound;
     end;
     Window(X1,Y1,X2,Y2);
     ClrScr;
     if Border In [0..2] then
     begin
      Write(BorderChar[Border,1]);
      for k:=2 to X2-X1 do Write(BorderChar[Border,2]);
      Write(BorderChar[Border,3]);
      for k:=2 to Y2-Y1 do
      begin
       GotoXY(1,k);
       Write(BorderChar[Border,4]);
       GotoXY(X2-X1+1,k);
       Write(BorderChar[Border,4]);
      end;
      GotoXY(1,Y2-Y1+1);
      Write(BorderChar[Border,5]);
      for k:=2 to X2-X1 do Write(BorderChar[Border,2]);
      Write(BorderChar[Border,6]);
     end;
     if Length(Header)> 0 then
     begin
      if Length(Header)> X2-X1-2 then Header[0] :=Chr(X2-X1-2);
      GotoXY((X2-X1-Length(Header)) Div 2 +2,1);
      Write(Header);
     end;
     if Clip then Window(X1+1,Y1+1,X2-1,Y2-1);
    end;
   End;

 {------------------------------------------------------}
 {                       FONT                           }
 {------------------------------------------------------}

   Type  {..............................................}

             PFontDesc =^TFontDesc;
             TFontDesc = record
                          NextFont: PFontDesc;
                          NFont   : Integer;
                          Name    : record
                          Case Byte Of
                           0: (FName: String);
                           1: (Flag : Byte;
                              Addrs : record
                              sa,oa : Word;
                           end);
                          end;
                          FirstChr: Byte;
                          LastChar: Byte;
                          Height  : ShortInt;
                          Bottom  : ShortInt;
                          Offs    : array[0..255] of Word;
                          Leng    : array[0..255] of Word;
                         end;

             TFontPara = record
                          ParPrefix   : Char;
                          CharsCount  : Word;
                          Reserv1     : Byte;
                          FirstChar   : Byte;
                          DataOffset  : Word;
                          FillFlag    : Byte;
                          UpperMargin : Byte;
                          Reserv2     : Byte;
                          LowerMargin : ShortInt;
                          Reserv3     : array[1..5] of Byte;
                         end;

             THead = array[1..4] of Char;

             Const {..........................................}

             FontList: PFontDesc =Nil;
             FontNumb: Integer =0;
             Head0   : THead = ('P','K',#8,#8);

             Var {............................................}

             FDesc: TFontDesc;
             F: File;
             Buf: array[1..128] Of Byte;
             Head: THead absolute Buf;
             FPar: TFontPara;

 {-----------------------------------------------------------------------}

   Function RegisterChrFile(S: String): Integer;
   Var
          k: Integer;
          Err: Boolean;
          P,PD: PFontDesc;
          ParOffs: Word;

 {-----------------------------------------------------}

   Function ReadFile(var Dest; Size: Word): Boolean;
   Begin
    BlockRead(F,Dest,Size,k);
    ReadFile:= k=Size;
   End;
 {-----------------------------------------------------}

   Begin
    if Pos('.',S) =0 then S:=S+'.CHR';
    if FontNumb <>0 then
    begin
     FDesc:=FontList^;
     With FDesc do
     While (NextFont <>Nil) and (S <>Name.FName) do
     FDesc:=NextFont^;
     if S =FDesc.Name.FName then
     begin
      RegisterChrFile:=FDesc.NFont;
      Exit;
     end;
    end;
    RegisterChrFile:=-1;
    Assign(F,S);
    {$I-}
    Reset(F,1);
    {$I+}
    if IOResult <>0 then Exit;
    if not ReadFile(Buf,128) then Exit;
    RegisterChrFile:=-2;
    if Head <>Head0 then Exit;
    repeat
     k:=1;
     While (k <=128) and (Buf[k] <>$1A) do Inc(k);
     if k =129 then
     if not ReadFile(Buf,128) then Exit;
    until Buf[k] =$1A;
    ParOffs:=Buf[k+1]+Buf[k+2] shl 8;
    Seek(F,ParOffs);
    if not ReadFile(FPar,16) or (FPar.ParPrefix <>'+') then Exit;
    RegisterChrFile:=-3;
    if MaxAvail <SizeOf(TFontDesc) then Exit;
    New(PD);
    With PD^,FPar do
    begin
     NextFont:=Nil;
     NFont:=FontNumb+1;
     Name.fName:=S;
     FirstChr:=FirstChar;
     LastChar:=FirstChar+CharsCount-1;
     Height:=UpperMargin;
     Bottom:=LowerMargin;
     RegisterChrFile:=-1;
     Seek(F,ParOffs+DataOffset-3*CharsCount);
     if not ReadFile(Offs[FirstChar],2*CharsCount) then
     begin
      Dispose(PD);
      Exit;
     end;
     for k:=FirstChar to LastChar do
     Offs[k]:=Offs[k]+ParOffs+DataOffset;
     for k:=FirstChar to Pred(LastChar) do
     Leng[k]:=Offs[k+1]-Offs[k];
  {
     DirectVideo:=False;
     Write(LastChar,'   ',FileSize(F)-Offs[Pred(LastChar)]-ParOffs);
  }
     Leng[LastChar]:=FileSize(F)-Offs[Pred(LastChar)]-ParOffs;
    end;
    if FontNumb =0 then FontList:=PD else
    begin
     P:=FontList;
     While P^.NextFont <>Nil do P:=P^.NextFont;
     P^.NextFont:=PD;
    end;
    Inc(FontNumb);
    RegisterChrFile:=FontNumb;
   End;
 {-----------------------------------------------------}

   Function RegisterChrFont(Font:Pointer): Integer;

   Type  {.............................................}

             TByte =array[0..65534] Of Byte;

   Var {...............................................}

             PH: ^THead;
             PP: ^TFontPara;
             PB: ^TByte absolute PH;
             P,PD: PFontDesc;
             k: Integer;
             ParOffset: Word;
             FileSize : Word;

   {...................................................}

   Begin
    PH:=Font;
    RegisterChrFont:=-2;
    if PH^ <>Head0 then Exit;
    k:=4;
    While (PB^[k] <>$1A) and (k <256) do Inc(k);
    if PB^[k] <>$1A then Exit;
    ParOffset:=PB^[k+1]+PB^[k+2] shl 8;
    FileSize:=PB^[k+7]+PB^[k+8] shl 8;
    PP:=Addr(PB^[ParOffset]);
    if PP^.ParPrefix <>'+' then Exit;
    RegisterChrFont:=-3;
    if MaxAvail <SizeOf(TFontDesc) then Exit;
    New(PD);
    With PD^,PP^ do
    begin
     NextFont:=Nil;
     NFont:=FontNumb+1;
     Name.Flag:=0;
     k:=ParOffset+DataOffset;
     Name.Addrs.sa:=Seg(PB^[k]);
     Name.Addrs.oa:=Ofs(PB^[k]);
     FirstChr:=FirstChar;
     LastChar:=FirstChar+CharsCount-1;
     Height:=UpperMargin;
     Bottom:=LowerMargin;
     k:=ParOffset+DataOffset-3*CharsCount;
     Move(PB^[k],Offs[FirstChar],2*CharsCount);
     for k:=FirstChar to Pred(LastChar) do
     Leng[k]:=Offs[k+1]-Offs[k];
     Leng[LastChar]:=FileSize-Offs[LastChar-1];
    end;
    if FontNumb =0 then FontList:=PD else
    begin
     P:=FontList;
     While P^.NextFont <>Nil do P:=P^.NextFont;
     P^.NextFont:=PD;
    end;
    Inc(FontNumb);
    RegisterChrFont:=FontNumb;
   End;
 {-----------------------------------------------------------------------}

   Procedure OutString(S: String; Font,Angle: Integer; MX,MY: Double);

   Var {...............................................}

         x0,y0: Integer;
         Ang  : Double;

  {....................................................}

    Procedure OutChar(var V);
    Var
           Vec : array[1..MaxInt] Of Word absolute V;
           k,op: Word;
           x,y,x1,y1,xx,yy: Integer;

  {....................................................}

     Procedure Coord(x,y: Integer; var xx,yy: Integer);
     Var  r,a: Double;
     Begin
      r:=sqrt(1.0*x*x+1.0*y*y);
      if x =0 then
      if y <0 then a:=-Pi/2 else a:=Pi/2
      else a:=ArcTan(y/x);
      a:=a+Ang;
      yy:=Round(r*Sin(a));
      xx:=Round(r*Cos(a));
     End;
  {....................................................}

     Begin
      k:=1;
      x:=x0;
      y:=y0;
      repeat
      op:=Vec[k] and $8080;
      xx:=Vec[k] and $7F;
      yy:=(Vec[k] shr 8) and $7F;
      if yy> 63 then Dec(yy,128);
      xx:=Round(xx*MX);
      yy:=Round(yy*MY);
      Coord(xx,yy,x1,y1);
      x1:=x0+x1;
      y1:=y0-y1;
      if op =$8080 then Line(x,y,x1,y1);
      if op <>0 then
      begin
       x:=x1;
       y:=y1;
      end;
      if op =0 then
      begin
       x0:=x;
       y0:=y;
      end
      else Inc(k);
     until op =0;
    End;

   Var {...............................................}

           F   : File;
           k,j : Word;
           c   : Byte;
           Buf : array[1..1000] Of Word;
           P   : PFontDesc;
           PB  : Pointer;

  {....................................................}

   Begin
    if (FontNumb =0) or (Font> FontNumb)
    or (S ='') then Exit;
    P:=FontList;
    Ang:=Angle*Pi/180;
    for k:=1 to Pred(Font) do P:=P^.NextFont;
    With P^ do
    begin
     if Name.FName <>'' then
     begin
      Assign(F,Name.FName);
      {$I-}
      Reset(F,1);
      {$I+}
      if IOResult <>0 then Exit;
     end;
     x0:=GetX;
     y0:=GetY;
     for k:=1 to Length(S) do
     begin
      c:=Ord(S[k]);
      if c In [FirstChr..LastChar] then
      if Name.Fname <>'' then
      begin
       {$I-}
       Seek(F,Offs[c]);
       BlockRead(F,Buf,Leng[c],j);
       {$I+}
       if (IOResult =0) and (Leng[c] =j) then OutChar(Buf);
      end
      else With Name.Addrs do
      begin
       PB:=Ptr(sa,oa+Offs[c]);
       OutChar(PB^);
      end;
     end;
     MoveTo(x0,y0);
     if Name.FName <>'' then Close(F);;
    end;
   End;

 {-----------------------------------------------------------------------}

  End.



