
  Unit Keb;
  Interface

  Type
             Trs = array[0..11] Of Byte;
         PtrByte = ^Byte;
  Const
            basa = $2f8;
            vect = $0b ;
            eirq = $0f7;
            dirq = $08 ;
            ncom = $01 ;
           nrate = $08 ;
           opros = 76  ;
           maxb  = 13  ;
           cp1: array[0..7] of Byte = ($04,$30,$31,$32,$30,$30,$31,$05);

   Var
           fox: Integer;
           rs_: Trs;
           oldhandler: Pointer;

           Procedure Pusk_RS;
           Procedure Stop_RS;
           Procedure Put_Keb(mtv: PtrByte);
           Function  Get_Keb: Integer;

 {-------------------------------------------------------------}

     Implementation
     Uses Crt,Dos;

     Var
     Regs: Registers;
     Item: Byte;

 {-------------------------------------------------------------}

   Procedure Handler; interrupt;
   Begin
    if fox <12 then
    begin rs_[fox]:=Port[basa]; Inc(fox); end;
    Port[$20]:=$20;
   End;

 {-------------------------------------------------------------}

   Procedure Pusk_RS;
   Begin
    With Regs do
    begin
     AH:=$04;        { function 04 int 14                       }
     AL:=$00;       { not break                                }
     BH:=$02;       { even parity                              }
     BL:=$00;       { 1 stop bit                               }
     CH:=$02;       { long word 7 bit                          }
     CL:=nrate;      { 05h-2400; 06h-4800; 07h-9600; 08h-19200  }
     DX:=ncom;       { 1 - COM2; 0 - COM1                       }
    end;
    Intr($14,Regs);

   { 57600 }
    Port[basa+3]:=Port[basa+3] or $80;
    PortW[basa]:=$0002;
    Port[basa+3]:=Port[basa+3] and $7f;
    GetIntVec(vect,oldhandler);
    SetIntVec(vect,@handler);
    InLine($fa);
    Port[$21]:=Port[$21] and eirq;
    Port[basa+3]:=Port[basa+3] and $7f;
    Port[basa+1]:=1;
    Item:=Port[basa];
    Item:=Port[basa+5];
    Item:=Port[basa+6];
    Port[basa+4]:=Port[basa+4] or $08;
    InLine($fb);
   End;

 {-------------------------------------------------------------}

   Procedure Stop_RS;
   Begin
    InLine($fa);
    Port[$21]:=Port[$21] or eirq;
    Port[basa+3]:=Port[basa+3] and $7f;
    Port[basa+1]:=0;
    Port[basa+4]:=Port[basa+4] and $f7;
    InLine($fb);
    SetIntVec(vect,oldhandler);
   End;

 {-------------------------------------------------------------}

   Procedure Trans(vol: Byte);
   Begin
    while Port[basa+5] and $32= 0 do;
    Port[basa]:=vol;
   End;

 {-------------------------------------------------------------}

   Procedure Put_Keb(mtv: PtrByte);
   var
         i: Integer;
       bcc: Byte;

   Begin
    Inc(mtv,4); bcc:=mtv^;
    for i:= 5 to 12 do begin Inc(mtv); Inc(bcc,mtv^); end;
    if bcc <$20 then Inc(bcc,$20);
    Inc(mtv); mtv^:=bcc; Dec(mtv,maxb);
    fox:=0;
    for i:=0 to maxb do begin Trans(mtv^); Inc(mtv); end;
   End;

 {-------------------------------------------------------------}

   Function Get_Keb: Integer;
   var
           l,n: LongInt;
         i,j,k: Integer;
        endptr: PtrByte;

   Begin
    l:=0; k:=0;
    for i:=0 to opros do
    begin
     fox:=0;
     if i= 0 then for j:= 0 to 7 do Trans(cp1[j]) else Trans($15);
     Delay(10);
     if fox =11 then
     begin
      Inc(k);
      Move(RS_[5],n,4); Inc(l,n);
     end;
    end;
    if k =0 then Get_Keb:=0 else Get_Keb:=l Div (k shl 1);
   End;

 {-------------------------------------------------------------}

  End.



